Package org.eclipse.jgit.transport

## Interface Connection

All Known Subinterfaces:
  `FetchConnection`, `PushConnection`

All Known Implementing Classes:
  `BaseConnection`, `BasePackFetchConnection`, `BasePackPushConnection`

    public interface Connection

Represent connection for operation on a remote repository.

Currently all operations on remote repository (fetch and push) provide information about remote refs. Every connection is able to be closed and should be closed - this is a connection client responsibility.

See Also:
  `Transport`

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `close()` Close any resources used by this connection.
`String` `getMessages()` Get the additional messages, if any, returned by the remote process.
`Ref` `getRef​(String name)` Get a single advertised ref by name.
`Collection<Ref>` `getRefs()` Get the complete list of refs advertised as available for fetching or pushing.
`Map<String,​Ref>` `getRefsMap()` Get the complete map of refs advertised as available for fetching or pushing.

### Method Detail

#### getRefsMap

    Map<String,​Ref> getRefsMap()

Get the complete map of refs advertised as available for fetching or pushing.

Returns:
  available/advertised refs: map of refname to ref. Never null. Not modifiable. The collection can be empty if the remote side has no refs (it is an empty/newly created repository).

#### getRefs

    Collection<Ref> getRefs()

Get the complete list of refs advertised as available for fetching or pushing.

The returned refs may appear in any order. If the caller needs these to be sorted, they should be copied into a new array or List and then sorted by the caller as necessary.

Returns:
  available/advertised refs. Never null. Not modifiable. The collection can be empty if the remote side has no refs (it is an empty/newly created repository).

#### getRef

    Ref getRef​(String name)

Get a single advertised ref by name.

The name supplied should be valid ref name. To get a peeled value for a ref (aka `refs/tags/v1.0^{}`) use the base name (without the `^{}` suffix) and look at the peeled object id.

Parameters:
  `name` - name of the ref to obtain.
Returns:
  the requested ref; null if the remote did not advertise this ref.

#### close

    void close()

Close any resources used by this connection.

If the remote repository is contacted by a network socket this method must close that network socket, disconnecting the two peers. If the remote repository is actually local (same system) this method must close any open file handles used to read the "remote" repository.

If additional messages were produced by the remote peer, these should still be retained in the connection instance for `getMessages()`.

#### getMessages

    String getMessages()

Get the additional messages, if any, returned by the remote process.

These messages are most likely informational or error messages, sent by the remote peer, to help the end-user correct any problems that may have prevented the operation from completing successfully. Application UIs should try to show these in an appropriate context.

The message buffer is available after `close()` has been called. Prior to closing the connection, the message buffer may be empty.

Returns:
  the messages returned by the remote, most likely terminated by a newline (LF) character. The empty string is returned if the remote produced no additional messages.